﻿using Syncfusion.JavaScript;
using Syncfusion.JavaScript.DataSources;
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Collections;
using System.Web.Script.Serialization;
using Syncfusion.JavaScript.Models;
using Syncfusion.EJ.Export;
using System.Reflection;
using Syncfusion.XlsIO;
using System.Reflection.Emit;
using System.Threading;

namespace MVCApp_13_2.Controllers
{
    public class HomeController : Controller
    {       
        public DataManager GridDataManager { get; set; } 

        JavaScriptSerializer serializer = new JavaScriptSerializer();

        List<Orders> order = new List<Orders>() { 
         new Orders(){ OrderID=1, CustomerID="VINET", EmployeeID=3, Freight = 43.2 },
         new Orders(){ OrderID=2, CustomerID="HANAR", EmployeeID=6, Freight = 34.2 },
         new Orders(){ OrderID=3, CustomerID="TOMPS", EmployeeID=7, Freight = 67.3 },
         new Orders(){ OrderID=4, CustomerID="VICTE", EmployeeID=2, Freight = 43.2 },
         new Orders(){ OrderID=5, CustomerID="RIOE", EmployeeID=1, Freight = 12.5 },
         new Orders(){ OrderID=6, CustomerID="HANAR", EmployeeID=3, Freight = 29.27 },
         new Orders(){ OrderID=7, CustomerID="VINET", EmployeeID=1, Freight = 49.82 },
         new Orders(){ OrderID=8, CustomerID="TOMPS", EmployeeID=5, Freight = 83.98 },
         new Orders(){ OrderID=9, CustomerID="VICTE", EmployeeID=4, Freight = 65.34 },
         new Orders(){ OrderID=10, CustomerID="RIOE", EmployeeID=6, Freight = 53.12 }
        };


        public ActionResult Index()
        {           
            return View();        
        }

        public ActionResult DataSource(DataManager dm)
        {
            return Json(GetDataSource(dm), JsonRequestBehavior.AllowGet);
        }

        //Action to export to excel
        [HttpPost]
        public void ExcelExport(string GridModel)
        {           
            GridProperties gridProperty = ConvertGridObject(GridModel);           

            ExcelExport exp = new ExcelExport();

            //Get IEnumerable result by processing DataManager.
            IEnumerable result = GetDataSource(GridDataManager).result;
          
            exp.Export(gridProperty, result, "Export.xlsx", ExcelVersion.Excel2010, false, false, "flat-saffron");

        }

        [HttpPost]
        public void PdfExport(string GridModel)
        {           
            GridProperties gridProperty = ConvertGridObject(GridModel);
          
            PdfExport exp = new PdfExport();

            IEnumerable result = GetDataSource(GridDataManager).result;
            
            exp.Export(gridProperty, result, "Export.pdf");
        }

        [HttpPost]
        public void WordExport(string GridModel)
        {
            GridProperties gridProperty = ConvertGridObject(GridModel);
                        
            WordExport exp = new WordExport();

            IEnumerable result = GetDataSource(GridDataManager).result;

            exp.Export(gridProperty, result, "Export.docx");
        }
        //Process DataManager with the order list and return result, count pair
        private DTO GetDataSource(DataManager dm) {

            IEnumerable Data = order;
            int count = order.Count;
            Syncfusion.JavaScript.DataSources.DataOperations operation = new Syncfusion.JavaScript.DataSources.DataOperations();
            if (dm.Sorted != null && dm.Sorted.Count > 0) //Sorting
            {
                Data = operation.PerformSorting(Data, dm.Sorted);
            }
            if (dm.Where != null && dm.Where.Count > 0) //Filtering
            {
                Data = operation.PerformWhereFilter(Data, dm.Where, dm.Where[0].Operator);                
            }
            if (dm.Skip != 0)
            {
                Data = operation.PerformSkip(Data, dm.Skip);
            }
            if (dm.Take != 0)
            {
                Data = operation.PerformTake(Data, dm.Take);
            }
            return new DTO { result = Data, count = count };
        }

        private GridProperties ConvertGridObject(string gridProperty)
        {
            JavaScriptSerializer serializer = new JavaScriptSerializer();
            IEnumerable div = (IEnumerable)serializer.Deserialize(gridProperty, typeof(IEnumerable));
            GridProperties gridProp = new GridProperties();
            foreach (KeyValuePair<string, object> ds in div)
            {
                var property = gridProp.GetType().GetProperty(ds.Key, BindingFlags.Instance | BindingFlags.Public | BindingFlags.IgnoreCase);
                
                //Check for `dataSource`
                if (ds.Key == "dataSource") {
                    //Deserialize the value to DataManager type.
                    GridDataManager = (DataManager)serializer.Deserialize(serializer.Serialize(ds.Value), typeof(DataManager));
                    continue;
                }
                
                if (property != null)
                {
                    Type type = property.PropertyType;
                    string serialize = serializer.Serialize(ds.Value);
                    object value = serializer.Deserialize(serialize, type);
                    property.SetValue(gridProp, value, null);
                }
            }
            return gridProp;
        }

        
    }

    public class Orders {
        public int OrderID { get; set; }
        public string CustomerID { get; set; }
        public int EmployeeID { get; set; }
        public double Freight { get; set; }        
        public DateTime? OrderDate
        {
            get;
            set;
        }
        public string ShipCity { get; set; }
        public string ShipName { get; set; }
        public string ShipAddress { get; set; }
    }

    public class DTO{
     public IEnumerable result { get; set; }
     public int count { get; set; }
    }
}